import { unlinkSync, readFileSync } from "fs";
import { dirname } from "path";
import { catchSync } from "dr-js/module/common/error";
import { writeFileAsync } from "dr-js/module/node/file/function";
import { createDirectory } from "dr-js/module/node/file/File";
import { addExitListenerSync } from "dr-js/module/node/system/ExitListener";
const configureFilePid = async ({filePid, shouldIgnoreExistPid = !1}) => {
  if (filePid) {
    !shouldIgnoreExistPid && catchSync(() => {
      const existingPid = readFileSync(filePid, {
        encoding: "utf8"
      });
      if (existingPid) {
        console.warn(`[FilePid] get existing pid: ${existingPid}, exit process...`);
        return process.exit(-1);
      }
    });
    await createDirectory(dirname(filePid));
    await writeFileAsync(filePid, `${process.pid}`);
    addExitListenerSync(exitState => {
      catchSync(unlinkSync, filePid);
    });
  }
};
export { configureFilePid };