import { ConfigPresetNode } from "dr-js/module/node/module/Option";
const {SingleString, SingleInteger, SinglePath, BooleanFlag} = ConfigPresetNode;
const getServerFormatConfig = (extendFormatList = []) => ({
  ...SingleString,
  optional: !0,
  name: "hostname",
  shortName: "H",
  extendFormatList: [ {
    ...SingleInteger,
    name: "port",
    shortName: "P"
  }, {
    ...BooleanFlag,
    name: "https",
    shortName: "S",
    extendFormatList: [ {
      ...SinglePath,
      name: "file-SSL-key"
    }, {
      ...SinglePath,
      name: "file-SSL-cert"
    }, {
      ...SinglePath,
      name: "file-SSL-chain"
    }, {
      ...SinglePath,
      name: "file-SSL-dhparam"
    } ]
  }, {
    ...SinglePath,
    optional: !0,
    name: "path-log",
    extendFormatList: [ {
      ...SingleString,
      optional: !0,
      name: "prefix-log-file"
    } ]
  }, {
    ...SinglePath,
    optional: !0,
    name: "file-pid",
    extendFormatList: [ {
      ...BooleanFlag,
      name: "pid-ignore-exist"
    } ]
  }, ...extendFormatList ]
});
const TokenCacheFormatConfig = {
  ...SinglePath,
  optional: !0,
  name: "file-token-cache",
  extendFormatList: [ {
    ...SingleInteger,
    optional: !0,
    name: "token-size"
  }, {
    ...SingleInteger,
    optional: !0,
    name: "token-expire-time"
  } ]
};
const AuthFormatConfig = {
  ...SinglePath,
  optional: !0,
  name: "file-auth-config",
  extendFormatList: [ {
    ...BooleanFlag,
    name: "auth-gen",
    extendFormatList: [ {
      ...SingleString,
      optional: !0,
      name: "auth-gen-tag"
    }, {
      ...SingleInteger,
      optional: !0,
      name: "auth-gen-size"
    }, {
      ...SingleInteger,
      optional: !0,
      name: "auth-gen-token-size"
    }, {
      ...SingleInteger,
      optional: !0,
      name: "auth-gen-time-gap"
    } ]
  } ]
};
const FileUploadFormatConfig = {
  ...SinglePath,
  optional: !0,
  name: "path-upload-root",
  extendFormatList: [ {
    ...SinglePath,
    name: "path-upload-merge"
  } ]
};
const StatusCollectFormatConfig = {
  ...SinglePath,
  optional: !0,
  name: "path-status-collect",
  extendFormatList: [ {
    ...SingleString,
    optional: !0,
    name: "status-collect-url"
  }, {
    ...SingleInteger,
    optional: !0,
    name: "status-collect-interval"
  } ]
};
const StatusReportFormatConfig = {
  ...SingleString,
  optional: !0,
  name: "status-report-process-tag"
};
export { getServerFormatConfig, TokenCacheFormatConfig, AuthFormatConfig, FileUploadFormatConfig, StatusCollectFormatConfig, StatusReportFormatConfig };