import { transformCache } from "dr-js/module/common/immutable/function";
import { responderSendBufferCompress } from "dr-js/module/node/server/Responder/Send";
import { prepareBufferDataHTML, prepareBufferDataJSON } from "../../function";
import { getHTML } from "./visualizeHTML";
const createResponderStatusVisualize = async (urlStatusFetch = "/status-state", urlAuthCheck = "/auth") => {
  const bufferData = await prepareBufferDataHTML(Buffer.from(getHTML({
    URL_STATUS_FETCH: urlStatusFetch,
    URL_AUTH_CHECK: urlAuthCheck,
    CONFIG_RENDER_PRESET: {
      StatusRaw: {
        positionScale: .05,
        horizontalDelta: 3600,
        mergeGapMax: 360
      },
      Merge0: {
        positionScale: .01,
        horizontalDelta: 21600,
        mergeGapMax: 1260
      },
      Merge1: {
        positionScale: .001,
        horizontalDelta: 86400,
        mergeGapMax: 3660
      },
      Merge2: {
        positionScale: 5e-4,
        horizontalDelta: 1209600,
        mergeGapMax: 9e4
      }
    }
  })));
  return store => responderSendBufferCompress(store, bufferData);
};
const createResponderStatusState = getStatusState => {
  const getBufferDataAsync = transformCache(statusState => prepareBufferDataJSON(Buffer.from(JSON.stringify(statusState))));
  return async store => responderSendBufferCompress(store, await getBufferDataAsync(getStatusState()));
};
export { createResponderStatusVisualize, createResponderStatusState };