import { COMMON_LAYOUT, COMMON_STYLE, COMMON_SCRIPT } from "dr-js/module/node/server/commonHTML";
import { DR_BROWSER_SCRIPT } from "../../HTML/function";
import { initAuthMask } from "../../HTML/AuthMask";
const getHTML = envObject => COMMON_LAYOUT([ "<title>Status Visualize</title>", COMMON_STYLE(), mainStyle ], [ '<div id="control-panel" style="overflow-x: auto; display: flex; flex-flow: row nowrap; box-shadow: 0 0 12px 0 #666;"></div>', '<div id="chart-panel" style="overflow: auto; flex: 1; min-height: 0;"></div>', COMMON_SCRIPT({
  ...envObject,
  initAuthMask,
  onload: onLoadFunc
}), DR_BROWSER_SCRIPT() ]);
const mainStyle = "<style>\nh2, h4 { padding: 4px 2px 2px; }\n\n.chart { user-select: none; position: relative; overflow: visible; margin: 10px; outline: none; }\n.chart-panel-vertical { pointer-events: none; position: absolute; left: 0; top: 0; overflow: visible; }\n.chart-label-vertical { position: absolute; left: 0; transform: translateY(50%); color: #666; z-index: 1; }\n.chart-main { display: flex; flex-flow: row nowrap; position: relative; overflow-x: auto; box-shadow: 0 0 2px 0 #6666; }\n.chart-label-horizontal { pointer-events: none; position: relative; overflow: visible; width: 0; box-shadow: 0 0 0 1px #8886; z-index: 1; }\n.chart-label-horizontal-tag { position: absolute; top: 0; color: #6666; }\n.chart-bar { position: relative; overflow: visible; flex: 0 0; height: 100%; }\n.chart-bar-value { position: absolute; left: 0; bottom: 0; width: 100%; background: #faa; }\n.chart-bar-value-range { position: absolute; left: 0; width: 100%; box-shadow: inset 0 0 2px 0 #666b; }\n.chart-bar-tag { display: none; pointer-events: none; position: absolute; left: 100%; top: 0; background: #ddd6; white-space: pre; z-index: 2; }\n.chart-bar:hover { box-shadow: 0 0 12px 0 #666; z-index: 2; }\n.chart-bar:hover .chart-bar-tag { display: initial; }\n\n.chart-panel-vertical, .chart-main { height: 100px; }\n.chart:focus .chart-panel-vertical, .chart:focus .chart-main { height: 300px; }\n</style>";
const onLoadFunc = () => {
  const {alert, qS, cE, URL_STATUS_FETCH, URL_AUTH_CHECK, CONFIG_RENDER_PRESET, initAuthMask, Dr: {Common: {Format, Math: {roundFloat, clamp}, Compare: {compareString}, Function: {lossyAsync}}}} = window;
  const renderChart = ({title, labelVerticalDataList, dataList, positionScale, horizontalDelta, formatPosition}) => [ `<h4>${title}</h4>`, '<div class="chart" tabindex="0">', '<div class="chart-panel-vertical">', ...labelVerticalDataList.map(([percent, label]) => `<div class="chart-label-vertical" style="bottom: ${percent}%;">${label}</div>`), "</div>", ...(({dataList, positionScale = 2, horizontalDelta = 50, formatPosition = String, prevHorizontalPosition = 1 / 0}) => [ '<div class="chart-main">', '<div class="chart-bar" style="pointer-events: none; flex-basis: 64px;"></div>', ...dataList.reduce((o, [tag, [from, to, value, min, max]]) => {
    if (prevHorizontalPosition - horizontalDelta >= from) {
      o.push(`<div class="chart-label-horizontal"><div class="chart-label-horizontal-tag">${formatPosition(from)}</div></div>`);
      prevHorizontalPosition = from;
    }
    o.push(`<div class="chart-bar" style="flex-basis: ${clamp(Math.abs((from - to) * positionScale), 4, 256)}px;${void 0 === value ? " pointer-events: none;" : ""}">`, tag && `<div class="chart-bar-tag">${tag}</div>`, ...void 0 === value ? [] : min !== max ? [ `<div class="chart-bar-value" style="height: ${value}%;"></div>`, `<div class="chart-bar-value-range" style="bottom: ${min}%; height: ${max - min}%"></div>` ] : [ `<div class="chart-bar-value" style="height: ${value}%;"></div>` ], "</div>");
    return o;
  }, []), '<div class="chart-bar" style="pointer-events: none; flex-basis: 256px;"></div>', "</div>" ])({
    dataList,
    positionScale,
    horizontalDelta,
    formatPosition
  }), "</div>" ];
  const parseNumberToValueMinMax = value => [ value, value, value ];
  const parseRangeRawToValueMinMax = ([value]) => [ value, value, value ];
  const parseRangeToValueMinMax = ([min, max, sum, size]) => [ roundFloat(sum / size), min, max ];
  const renderValueTrackList = ({title, resultTrackList, positionFrom, positionTo, valueMin, valueMax, formatPosition = String, formatValue = roundFloat, positionScale, horizontalDelta}) => {
    const valueRange = valueMax - valueMin;
    const normalizeValue = valueRange ? value => (value - valueMin) / valueRange * 100 : () => 50;
    const labelVerticalDataList = [ 0, .25, .5, .75, 1 ].map(value => [ 100 * value, formatValue(valueMin + value * valueRange) ]);
    const dataList = resultTrackList.map(([from, to, value, min, max]) => {
      if (void 0 === value) return [ "", [ from, to ] ];
      const tagList = [ `from:  ${formatPosition(from)}`, `to:    ${formatPosition(to)}`, `value: ${formatValue(value)}` ];
      min !== max && tagList.push(`min:   ${formatValue(min)}`, `max:   ${formatValue(max)}`);
      const valueData = [ from, to, normalizeValue(value) ];
      min !== max && valueData.push(normalizeValue(min), normalizeValue(max));
      return [ tagList.join("\n"), valueData ];
    });
    return renderChart({
      title,
      labelVerticalDataList,
      dataList,
      positionScale,
      horizontalDelta,
      formatPosition
    });
  };
  const renderStatusList = ({dataList, getPositionData, parsePositionData, preset = {}}, {statusKeyList, statusPresetList, statusSkipIndexSet, getStatusData, parseStatusData}) => statusKeyList.map((key, keyIndex) => !statusSkipIndexSet.has(keyIndex) && ((dataList, getPositionData, parsePositionToRange, getValueData, parseValue, preset = {}) => {
    let resultTrackList = [];
    let {valueMin = 1 / 0, valueMax = -1 / 0, mergeGapMax = 0} = preset;
    let prevPositionTo;
    dataList.forEach(data => {
      const positionData = getPositionData(data);
      const valueData = getValueData(data);
      if (!positionData || !valueData) return;
      const [from, to] = parsePositionToRange(positionData);
      const [value, min, max] = parseValue(valueData);
      valueMin = Math.min(valueMin, min);
      valueMax = Math.max(valueMax, max);
      prevPositionTo && prevPositionTo !== from && resultTrackList.push([ prevPositionTo, from ]);
      resultTrackList.push([ from, to, value, min, max ]);
      prevPositionTo = to;
    });
    if (mergeGapMax) {
      let prevTrack;
      resultTrackList = resultTrackList.reduce((o, track) => {
        const [from, to, value] = track;
        if (value) {
          o.push(track);
          prevTrack = track;
        } else {
          prevTrack && Math.abs(from - to) <= mergeGapMax ? prevTrack[1] = to : o.push(track);
          prevTrack = void 0;
        }
        return o;
      }, []);
    }
    return {
      ...preset,
      resultTrackList,
      positionFrom: resultTrackList.length ? resultTrackList[0][0] : 1 / 0,
      positionTo: resultTrackList.length ? resultTrackList[resultTrackList.length - 1][1] : -1 / 0,
      valueMin,
      valueMax
    };
  })(dataList, getPositionData, parsePositionData, data => getStatusData(data, keyIndex), parseStatusData, {
    title: key,
    ...preset,
    ...statusPresetList[keyIndex] || {}
  })).filter(v => v && v.resultTrackList.length);
  const renderStatusRawList = ({dataList, getPositionData = GET_STATE().getTimestampRawData, parsePositionData = ([value]) => [ value, value - 1 ], preset}) => [ ...renderStatusList({
    dataList,
    getPositionData,
    parsePositionData,
    preset
  }, {
    ...GET_STATE().packSum,
    getStatusData: (data, keyIndex) => data.sumRawList[keyIndex],
    parseStatusData: parseNumberToValueMinMax
  }), ...renderStatusList({
    dataList,
    getPositionData,
    parsePositionData,
    preset
  }, {
    ...GET_STATE().packRange,
    getStatusData: (data, keyIndex) => data.rangeRawList[keyIndex],
    parseStatusData: parseRangeRawToValueMinMax
  }) ];
  const renderMergeList = ({dataList, getPositionData = GET_STATE().getTimestampData, parsePositionData = ([min, max]) => [ max, min - 1 ], preset}) => [ ...renderStatusList({
    dataList,
    getPositionData,
    parsePositionData,
    preset
  }, {
    ...GET_STATE().packSum,
    getStatusData: (data, keyIndex) => data.sumList[keyIndex],
    parseStatusData: parseNumberToValueMinMax
  }), ...renderStatusList({
    dataList,
    getPositionData,
    parsePositionData,
    preset
  }, {
    ...GET_STATE().packRange,
    getStatusData: (data, keyIndex) => data.rangeList[keyIndex],
    parseStatusData: parseRangeToValueMinMax
  }) ];
  const createRenderStatusButton = (id, title, renderFunc, getDataList, preset) => {
    if (qS(`#${id}`)) return;
    qS("#control-panel").appendChild(cE("button", {
      id,
      innerText: title,
      onclick: () => qS("#chart-panel", [ `<h2>${title}</h2>`, ...renderFunc({
        dataList: getDataList(),
        preset
      }).sort((a, b) => a.order - b.order || compareString(a.title, b.title)).map(valueTrack => renderValueTrackList(valueTrack).join("\n")) ].join("<br />"))
    }));
  };
  const formatTimestamp = value => {
    const [, date, time] = /(\d+-\d+-\d+)T(\d+:\d+:\d+)/.exec(new Date(1e3 * value).toISOString());
    return `${time} ${date.replace(/-/g, ".")}`;
  };
  const formatBinaryData = value => `${Format.binary(value)}B`;
  const fetchStatusState = lossyAsync(async authFetch => {
    const {sumKeyList, rangeKeyList, statusRawList, merge0List, merge1List, merge2List} = await (await authFetch(URL_STATUS_FETCH)).json();
    const sumPresetList = [];
    sumPresetList[sumKeyList.indexOf("error")] = {
      order: 0,
      title: "error count",
      valueMin: 0
    };
    sumPresetList[sumKeyList.indexOf("retryCount")] = {
      order: 0,
      title: "retry count",
      valueMin: 0
    };
    const rangePresetList = [];
    rangePresetList[rangeKeyList.indexOf("timeOk")] = {
      order: 1,
      valueMin: 0,
      valueMax: 100,
      formatValue: Format.time
    };
    rangePresetList[rangeKeyList.indexOf("timeDownload")] = {
      order: 1,
      valueMin: 0,
      valueMax: 10,
      formatValue: Format.time
    };
    rangePresetList[rangeKeyList.indexOf("systemMemoryUsed")] = {
      order: 2,
      valueMin: 0,
      valueMax: 1,
      formatValue: Format.percent
    };
    rangePresetList[rangeKeyList.indexOf("processMemoryRSS")] = {
      order: 2,
      valueMin: 0,
      valueMax: 50331648,
      formatValue: formatBinaryData
    };
    rangePresetList[rangeKeyList.indexOf("processMemoryHeap")] = {
      order: 2,
      valueMin: 0,
      valueMax: 50331648,
      formatValue: formatBinaryData
    };
    rangeKeyList.forEach((rangeKey, index) => {
      rangeKey.includes("ProcessorUsed") && (rangePresetList[index] = {
        order: 2,
        valueMin: 0,
        valueMax: 1,
        formatValue: Format.percent
      });
    });
    const timestampIndex = rangeKeyList.indexOf("timestamp");
    const sumSkipIndexSet = new Set([]);
    const rangeSkipIndexSet = new Set([ rangeKeyList.indexOf("timestamp"), rangeKeyList.indexOf("timestampStatus") ]);
    STATE = {
      statusRawList,
      merge0List,
      merge1List,
      merge2List,
      getTimestampRawData: data => data.rangeRawList[timestampIndex],
      getTimestampData: data => data.rangeList[timestampIndex],
      packSum: {
        statusKeyList: sumKeyList,
        statusPresetList: sumPresetList,
        statusSkipIndexSet: sumSkipIndexSet
      },
      packRange: {
        statusKeyList: rangeKeyList,
        statusPresetList: rangePresetList,
        statusSkipIndexSet: rangeSkipIndexSet
      }
    };
    qS("#chart-panel", "");
    createRenderStatusButton("render-status-raw", "RenderStatusRaw", renderStatusRawList, () => GET_STATE().statusRawList, {
      ...CONFIG_RENDER_PRESET.StatusRaw,
      formatPosition: formatTimestamp
    });
    createRenderStatusButton("render-merge-0", "RenderMerge0", renderMergeList, () => GET_STATE().merge0List, {
      ...CONFIG_RENDER_PRESET.Merge0,
      formatPosition: formatTimestamp
    });
    createRenderStatusButton("render-merge-1", "RenderMerge1", renderMergeList, () => GET_STATE().merge1List, {
      ...CONFIG_RENDER_PRESET.Merge1,
      formatPosition: formatTimestamp
    });
    createRenderStatusButton("render-merge-2", "RenderMerge2", renderMergeList, () => GET_STATE().merge2List, {
      ...CONFIG_RENDER_PRESET.Merge2,
      formatPosition: formatTimestamp
    });
    qS("#render-status-raw").click();
  }).trigger;
  let STATE;
  const GET_STATE = () => {
    if (STATE) return STATE;
    alert("data not ready!");
    throw new Error("data not ready!");
  };
  initAuthMask({
    urlAuthCheck: URL_AUTH_CHECK,
    onAuthPass: ({authFetch}) => {
      qS("#control-panel").appendChild(cE("button", {
        innerHTML: "ReloadData",
        onclick: () => fetchStatusState(authFetch)
      }));
      fetchStatusState(authFetch);
    }
  });
};
export { getHTML };